︠12a531ec-e6f3-46b9-92cc-3d3dde1ad657is︠
%auto
%md(hide = True)
# Fourier analysis
︡26306648-eb45-4100-bc49-2a4d8b9a0acc︡{"hide":"input"}︡{"md":"# Fourier analysis"}︡{"done":true}︡
︠92c2c0e8-9ca0-4d32-af2f-2fcd59a0bd0ai︠
%md(hide = True)
Code adapted from https://arachnoid.com/sage/fourier.html and https://youtu.be/TwWpewdNOpg
︡cd435545-0138-4df6-9649-4f00ce8f1a87︡{"done":true,"md":"Code adapted from https://arachnoid.com/sage/fourier.html and https://youtu.be/TwWpewdNOpg"}
︠825deafd-757c-4b6b-89e7-381d1eb4f862s︠
from sage.plot.bar_chart import BarChart
var('t')
︡26a1f8af-df07-46ea-b00c-0ef1b2646ba7︡{"stdout":"t\n"}︡{"done":true}︡
︠10c0c32c-33cd-4754-895e-29c9eb0b52a2i︠
%md(hide = True)
## Example 1
︡dcfdd323-5cc8-4488-8405-de53f5624608︡{"done":true,"md":"## Example 1"}
︠53c55121-6e04-4bb0-90bd-b5ac3689ff59i︠
%md(hide =  True)
$f_{1}(t) = 12\sin(2\pi(3t)) + 11\sin(2\pi(4t)) + 10\sin(2\pi(5t)) + 9\sin(2\pi(6t))$
︡87fd621a-4020-49b6-920a-0787a38bd2ef︡{"done":true,"md":"$f_{1}(t) = 12\\sin(2\\pi(3t)) + 11\\sin(2\\pi(4t)) + 10\\sin(2\\pi(5t)) + 9\\sin(2\\pi(6t))$"}
︠a38392e7-3650-4a00-9969-3277278f3200s︠

f1(t) = 12*sin(2*pi*(3*t)) + 11*sin(2*pi*(4*t)) + 10*sin(2*pi*(5*t)) + 9*sin(2*pi*(6*t))

plot(f1, (t, -1, 2))
︡06a07a13-5348-48fa-836a-e38d81946794︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_GsRQ2C.svg","show":true,"text":null,"uuid":"ad2a544f-e3af-4e22-a46b-8dea67d86dc2"},"once":false}︡{"done":true}︡
︠bdffe0bc-ca46-4086-a7dd-8b0cf12a6971s︠
# Choose number of samples
size1 = 25

# Create an empty Fast Fourier Transform object
fft_data1 = FFT(size1)

# Populate it with data sampled from f1.
for t in range(size1):
    fft_data1[t] = f1(t/size1)

# Plot results
plot(fft_data1)
︡33003cfc-1518-4a79-afbb-3e9280d09325︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_gEL81H.svg","show":true,"text":null,"uuid":"76e72ddc-0cf4-4fe2-a955-5165b453d7cc"},"once":false}︡{"done":true}︡
︠fabc2b71-5a7f-47d3-a8db-805adb20b277︠

# Fourier transform to convert to frequency domain
# (Modifies fft_data1 in place.)
fft_data1.forward_transform()
︡c024b353-5465-40ff-9d6d-7459e85a8dfe︡{"done":true}︡
︠30b703c3-0ae3-4071-b5c0-b6a327a4c9bes︠
# Create empty array for amplitudes
fft_freq1 = [0 for j in range(size1/2)]

# Populate it with the computed amplitudes
# (For technical reasons, we only have to compute this for half of the sampled frequencies)
for f in range(size1/2):
    fft_freq1[f] = abs(vector(fft_data1[f]))/(size1/2)

# Plot results
bar_chart(fft_freq1)
︡b28ec806-5df4-41eb-b5cd-61da17adaa53︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_L7wvyx.svg","show":true,"text":null,"uuid":"de56be6b-60cb-48ec-b80a-2e93b1bceece"},"once":false}︡{"done":true}︡
︠c5229e59-da73-49ca-90ea-3c23294dc1c5i︠
%md(hide = True)
## Example 2
︡2efa9de0-8f42-4aec-8bcb-45b551a5f956︡{"done":true,"md":"## Example 2"}
︠75d5b26b-aa04-4ecc-9663-81d30756072di︠
%md(hide = True)
$f_{2}(t) = \mathrm{sgn}\left( \sin(2\pi t) \right)$
︡8fd7a5d0-20dc-4161-b92b-b03eb2d53a6d︡{"done":true,"md":"$f_{2}(t) = \\mathrm{sgn}\\left( \\sin(2\\pi t) \\right)$"}
︠bbe305f0-3a4a-4530-8f0c-dfe62637ad9es︠
f2(t) = sgn((sin(2*pi*t)))

plot(f2, (t, -1, 2))
︡d0c3c577-471f-4978-92d6-9fa898261666︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_HoQhdk.svg","show":true,"text":null,"uuid":"bb94a78a-23f4-4adc-95cd-ac2dfe8a149f"},"once":false}︡{"done":true}︡
︠92d3f08a-8c78-4031-b2a1-01bfc2afbf84︠
# Choose number of samples
size2 = 100

# Create an empty Fast Fourier Transform object
fft_data2 = FFT(size2)

# Populate it with data sampled from f2.
for t in range(size2):
    fft_data2[t] = f2(t/size2)

# Plot results
plot(fft_data2)
︡7d75520e-a00d-4977-8289-d6c593cbca6b︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_bjeQYM.svg","show":true,"text":null,"uuid":"b2432e7f-035b-4242-a93c-2b6f007f9e51"},"once":false}︡{"done":true}︡
︠fbd413d9-9849-4c24-b808-3892bff3b3fb︠
# Fourier transform to convert to frequency domain
# (Modifies fft_data2 in place.)
fft_data2.forward_transform()
︡759e09b6-abf7-446a-97f8-b77914208494︡{"done":true}︡
︠9cbc81c8-56c4-4688-88ad-1c00a2f5b875s︠

# Create empty array for amplitudes
fft_freq2 = [0 for j in range(size2/2)]

# Populate it with the computed amplitudes
# (For technical reasons, we only have to compute this for half of the sampled frequencies)
for f in range(size2/2):
    fft_freq2[f] = N(pi/4) * abs(vector(fft_data2[f]))/(size2/2) # Not sure why the extra factor of pi/4 is necessary.

# Plot results
bar_chart(fft_freq2[0:14])
︡0dbe6b2c-3c64-47a8-a4d3-469e688c7365︡{"file":{"filename":"/projects/eb06b2a6-9e27-4cd0-a417-7b05ec92475c/.sage/temp/compute5-us/28004/tmp_h053Od.svg","show":true,"text":null,"uuid":"1a9be8d5-266d-4d2a-afb2-8b23a3f51891"},"once":false}︡{"done":true}︡









